<?php

class FolderManager {

	static private $instance;
	private $folders;
	private $fsfolders;
	private $db;
	
	public function __construct() {

		$dbRoot = ServerConfig::getDatabasePath() . "../general/";
		$dbFile = realpath($dbRoot) . "/system.s3db";
		$this->db = new PDO("sqlite:" . $dbFile);
		
		// Get folder URL
		$URL = ServerConfig::getServerUrl() . "cron_admin.pl?command=list&foldersonly=1";
		
		// Get folder content
		$content = @file($URL);
			
		if (empty($content)) die("Error: 23232325");
		
		// Variable to hold folders
		$this->folders = array();
		$this->fsfolders = array();

		// Parse folders		
		foreach ($content as $line) {
			$line = trim($line);
			if ($line == "SERVER_FOLDERS" || $line == "") continue;
			$sql = "INSERT OR IGNORE INTO Folders (name,lastseen) VALUES ('" . $line . "', '" . time() . "');";
			$this->db->exec($sql);
			$sql = "UPDATE Folders SET name='".$line."',lastseen='".time()."' WHERE name ='".$line."';";
			$this->db->exec($sql);
			$this->fsfolders[] = new Folder($line);
		}		
		
		$sql = "SELECT name FROM Folders;";
		foreach ($this->db->query($sql) as $row) {
			$this->folders[] = new Folder($row[0]);
		}
	}
	
	static public function getInstance() {
		if (empty(self::$instance)) {
			self::$instance = new FolderManager();
		}
		return self::$instance;
	}
	
	static public function getFolders() {
		if (empty(self::$instance)) {
			self::$instance = new FolderManager();
		}
		return self::$instance->folders;
	}
	
	static public function getFoldersFromFS() {
		if (empty(self::$instance)) {
			self::$instance = new FolderManager();
		}
		return self::$instance->fsfolders;
	}

	static public function isFolderLastSeenExpired($name) {
		self::$instance = self::getInstance();
		$lastSeenExpiry = 24*60*60;
		$lastSeen = "";
		
		$sql = "SELECT lastseen FROM Folders where name='".$name."';";
		foreach (self::$instance->db->query($sql) as $row) {
			$lastSeen = $row[0];
		}
		$diff = time() - $lastSeen;
		$expired = $diff >= $lastSeenExpiry ? 1 : 0;
		Logger::Debug("FolderManager::isFolderLastSeenExpired()", $name . " is last seen on ".$lastSeen);
		return $expired;
	}
	
    static public function checkFolders($name) {
		foreach (self::getFoldersFromFS() as $folder) {
			if($name === $folder->getName()){
				return true;
			}
		}
		Logger::Debug("FolderManager::checkFolders()", $name . " not seen on the Filesystem");
		return false;
	}
}

?>